unit WarEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, head, inifiles, ExtCtrls, StdCtrls, math, ComCtrls;

type
  TForm10 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ListBox1: TListBox;
    Button1: TButton;
    ComboBox1: TComboBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel3: TPanel;
    Label1: TLabel;
    Image1: TImage;
    StatusBar1: TStatusBar;
    CheckBox1: TCheckBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure displayW;
    procedure FormResize(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  warFile: TWfile;
  wselect: array of TSelect;
  poseditmap: tbitmap;
  wareditgrp: array of Tgrppic;
  wareditmapfile: Tmapstruct;

procedure readWini;
function readW(grp: string; PWF: PWFile): boolean;
procedure CalWnamePos(PWF: PWFile);
function calWname(index: integer): widestring;
procedure readWareditgrp;
procedure displaywareditmap(waropMap: Pmap; waropbmp2:PNTbitmap);

implementation

uses
  main, Redit, ReditForm,warmapedit;

{$R *.dfm}

procedure readWini;
var
  iniF: Tinifile;
  inifilename, tempstr: string;
  strlist: Tstringlist;
  i1,i2: integer;
  strnum: integer;
begin
  //

  try
    inifilename := ExtractFilePath(Paramstr(0)) + 'UPedit.ini';
    iniF := TIniFile.Create(inifilename);
    //Wtypenumber := iniF.ReadInteger('W_Modify','TypeNumber',0);
    //edit1.Text := inttostr(typenumber);

      // setlength(Wini, Wtypenumber);
      // setlength(Wtypedataitem, Wtypenumber);
      // setlength(Wtypename, Wtypenumber);
      strlist := Tstringlist.Create;
        //Wtypename[I1] := iniF.ReadString('W_Modify', 'typename' + inttostr(i1), '');
        Wtypedataitem := iniF.ReadInteger('W_Modify', 'typedataitem', 0);

        if Wtypedataitem > 0 then
        begin
          setlength(Wini.Wterm, Wtypedataitem);
          for i1 := 0 to Wtypedataitem - 1 do
          begin
            strlist.Clear;
            tempstr := iniF.ReadString('W_Modify','data(' + inttostr(i1) + ')','');
            if tempstr<>'' then
            begin
              strnum := ExtractStrings([' '], [], Pwidechar(tempstr), Strlist);
              if strnum = 11 then
              begin

                with Wini.Wterm[i1] do
                begin
                  datanum := strtoint(strlist.Strings[0]);
                  incnum := strtoint(strlist.Strings[1]);
                  datalen := strtoint(strlist.Strings[2]);
                  isstr := strtoint(strlist.Strings[3]);
                  isname := strtoint(strlist.Strings[4]);
                  quote := strtoint(strlist.Strings[5]);
                  name := strlist.Strings[6];
                  note := strlist.Strings[7];
                  ismapnum:= strtoint(strlist.Strings[8]);
                  labeltype:= strtoint(strlist.Strings[9]);
                  labelnum:= strtoint(strlist.Strings[10]);
                end;
              end;
            end;
          end;

        end;

        strlist.free;


    iniF.free;
  except
    //showmessage('ȡiniļ');
    exit;
  end;
end;

function readW(grp: string; PWF: PWFile): boolean;
var
  offset: array of integer;
  i1,i2,i3,i4,i5: integer;
  size, F, temp, filelen: Integer;
begin
  result := false;
    if fileexists(grp) then
    begin
      try
        size := 0;
          for i2 := 0 to Wtypedataitem - 1 do
          begin
            if wini.Wterm[i2].datanum > 0 then
            for i3 := i2 to i2 + wini.Wterm[i2].incnum - 1 do
            begin
              inc(size, wini.Wterm[i2].datanum * wini.Wterm[i3].datalen);
            end;
          end;
        F := fileopen(grp, fmopenread);
        filelen := fileseek(F,0,2);
        fileseek(F,0,0);
        size := filelen div size;
        PWF.Wtype.datanum := size;
        setlength(PWF.Wtype.Rdata, PWF.Wtype.datanum);

          for i2 := 0 to PWF.Wtype.datanum - 1 do
          begin
            temp := 0;
            for i3 := 0 to Wtypedataitem - 1 do
              if Wini.Wterm[i3].datanum > 0 then
                inc(temp);
            PWF.Wtype.Rdata[i2].num := temp;
            setlength(PWF.Wtype.Rdata[i2].Rdataline, temp);
            temp := -1;
            for I3 := 0 to Wtypedataitem - 1 do
            begin
              if Wini.Wterm[i3].datanum > 0 then
              begin
                inc(temp);
                if Wini.Wterm[i3].isname = 1 then
                  PWF.Wtype.namepos := temp;
                PWF.Wtype.Rdata[i2].Rdataline[temp].len := Wini.wterm[i3].datanum;
                setlength(PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray, Wini.wterm[i3].datanum);
               // setlength(Rfile[i1].Rdata[i2].Rdataline[i3].datatype, Rini[i1].Rterm[i3].incnum);
                //setlength(Rfile[i1].Rdata[i2].Rdataline[i3].Rarray, Rini[i1].Rterm[i3].incnum);
                for I4 := 0 to Wini.wterm[i3].datanum - 1 do
                begin
                  PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray[i4].incnum := wini.Wterm[i3].incnum;
                  setlength(PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray[i4].dataarray, wini.Wterm[i3].incnum);
                  for i5 := 0 to Wini.Wterm[i3].incnum - 1 do
                  begin
                    PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray[i4].dataarray[i5].datatype := Wini.Wterm[i3 + i5].isstr;
                    PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray[i4].dataarray[i5].datalen := Wini.Wterm[i3 + i5].datalen;
                    if PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray[i4].dataarray[i5].datatype = 0 then
                      fileread(F, PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray[i4].dataarray[i5].number, Wini.Wterm[i3 + i5].datalen)
                    else
                    begin
                      //setlength(Rfile[i1].Rdata[i2].Rdataline[i3].Rarray[i4].dataarray[i5].str, Rini[i1].Rterm[i3 + i5].datalen);
                      //fileread(F, Rfile[i1].Rdata[i2].Rdataline[i3].Rarray[i4].dataarray[i5].str[0], Rini[i1].Rterm[i3 + i5].datalen);
                      setlength(PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray[i4].dataarray[i5].str,Wini.Wterm[i3 + i5].datalen);
                      fileread(F, PWF.Wtype.Rdata[i2].Rdataline[temp].Rarray[i4].dataarray[i5].str[1], Wini.Wterm[i3 + i5].datalen);
                      //Rfile[i1].Rdata[i2].Rdataline[i3].Rarray[i4].dataarray[i5].str := TtoS(Rfile[i1].Rdata[i2].Rdataline[i3].Rarray[i4].dataarray[i5].str);
                    end;
                  end;
                end;

              end;
            end;
          end;

        fileclose(F);

        result := true;
      except
        //showmessage('ȡļ');
        exit;
      end;
    end;
end;



procedure TForm10.Button1Click(Sender: TObject);
var
  I: integer;
begin
  readW(gamepath + wardata,@warFile);
  CalWnamepos(@warFile);
  combobox1.Clear;
  for I := 0 to warfile.Wtype.datanum - 1 do
    combobox1.Items.Add(CalWname(I));
  combobox1.ItemIndex := 0;
  displayW;
end;

procedure TForm10.Button2Click(Sender: TObject);
var
  I1,I2,I3,I4,i5, F: integer;
begin
  F := filecreate(gamepath + wardata);
  for i1 := 0 to WarFile.Wtype.datanum - 1 do
    for I2 := 0 to warFile.Wtype.Rdata[i1].num - 1 do
      for i3 := 0 to warFile.Wtype.Rdata[i1].Rdataline[i2].len - 1 do
        for i4 := 0 to warFile.Wtype.Rdata[i1].Rdataline[i2].Rarray[i3].incnum - 1 do
        begin
          if warFile.Wtype.Rdata[i1].Rdataline[i2].Rarray[i3].dataarray[i4].datatype = 0 then
            filewrite(F,warFile.Wtype.Rdata[i1].Rdataline[i2].Rarray[i3].dataarray[i4].number, warFile.Wtype.Rdata[i1].Rdataline[i2].Rarray[i3].dataarray[i4].datalen)
          else
            filewrite(F,warFile.Wtype.Rdata[i1].Rdataline[i2].Rarray[i3].dataarray[i4].str[1], warFile.Wtype.Rdata[i1].Rdataline[i2].Rarray[i3].dataarray[i4].datalen);
        end;

  fileclose(F);

end;

procedure TForm10.Button3Click(Sender: TObject);
begin
  if MessageBox(Self.Handle, 'ǷԵǰֵΪȱʡֵ',  '', MB_OKCANCEL) = 1 then
  begin
  inc(warfile.Wtype.datanum);
  setlength(warfile.Wtype.Rdata, warfile.Wtype.datanum);
  copyRdata(@warfile.Wtype.Rdata[combobox1.ItemIndex],@warfile.Wtype.Rdata[warfile.Wtype.datanum - 1]);
  combobox1.Items.Add(CalWname(Warfile.Wtype.datanum - 1));
  combobox1.ItemIndex := Warfile.Wtype.datanum - 1;
  displayW;
  end;
end;

procedure TForm10.Button4Click(Sender: TObject);
var
  temp: integer;
  arrg:boolean;
begin
  if WarFile.Wtype.datanum = 1 then
    showmessage('ֻʣһ벻Ҫɾ')
  else
  begin
    if MessageBox(Self.Handle, 'Ƿɾһ',  'ɾһ', MB_OKCANCEL) = 1 then
    begin
      temp := combobox1.ItemIndex;
      arrg := false;
      if temp = WarFIle.Wtype.datanum - 1 then
        arrg := true;
      dec(WarFIle.Wtype.datanum);
      setlength(Warfile.Wtype.Rdata, Warfile.Wtype.datanum);
      combobox1.Items.Delete(WarFIle.Wtype.datanum);
      combobox1.ItemIndex := temp;
      if arrg then
        displayW;
    end;
  end;
end;

procedure TForm10.CheckBox1Click(Sender: TObject);
var
  wareditbufbmp:Tbitmap;
begin
  if checkbox1.Checked then
  begin
  try
  image1.Visible := true;
  displaywareditmap(@wareditmapfile.map[WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[warfile.Wtype.mappos].Rarray[0].dataarray[0].number], @poseditmap);
  wareditbufbmp := tbitmap.Create;
  wareditbufbmp.Width := image1.Width;
  wareditbufbmp.Height := image1.Height;
  wareditbufbmp.Canvas.StretchDraw(wareditbufbmp.Canvas.ClipRect,poseditmap);
  image1.Canvas.CopyRect(image1.Canvas.ClipRect, wareditbufbmp.Canvas, wareditbufbmp.Canvas.ClipRect);
  wareditbufbmp.free;
  except
    exit;
  end;
  end
  else
  begin
    image1.visible := false;
  end;
end;

procedure TForm10.ComboBox1Select(Sender: TObject);
var
  wareditbufbmp: Tbitmap;
begin
  displayW;
  if checkbox1.Checked then
  begin
  try
  displaywareditmap(@wareditmapfile.map[WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[warfile.Wtype.mappos].Rarray[0].dataarray[0].number], @poseditmap);
  wareditbufbmp := tbitmap.Create;
  wareditbufbmp.Width := image1.Width;
  wareditbufbmp.Height := image1.Height;
  wareditbufbmp.Canvas.StretchDraw(wareditbufbmp.Canvas.ClipRect,poseditmap);
  image1.Canvas.CopyRect(image1.Canvas.ClipRect, wareditbufbmp.Canvas, wareditbufbmp.Canvas.ClipRect);
  wareditbufbmp.free;
  except
    exit;
  end;
  end;
end;

procedure TForm10.displayW;
var
  I1, I2,I3,I4, temp, temp2: integer;
  tempstr: string;
begin
  if combobox1.ItemIndex >= 0 then
  begin
    for i1 := 0 to WarFile.Wtype.Rdata[combobox1.ItemIndex].num - 1 do
      inc(temp, WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].len * WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[0].incnum);
    setlength(Wselect, temp);
    listbox1.Clear;
    temp := -1;
    temp2 := 0;
    for i1 := 0 to warfile.Wtype.Rdata[combobox1.ItemIndex].num - 1 do
    begin
      for i2 := 0 to warfile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].len - 1 do
        for i3 := 0 to warfile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].incnum - 1 do
        begin
          tempstr := '';
          if warfile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].len > 1 then
            for i4 := listbox1.Canvas.TextWidth(displayname(wini.Wterm[temp2 + i3].name) + inttostr(i2 + 1)) div 7 to 15 do
              tempstr := tempstr + '  '
          else
            for i4 := listbox1.Canvas.TextWidth(displayname(wini.Wterm[temp2 + i3].name)) div 6 to 15 do
              tempstr := tempstr + '  ';
          if WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].datatype = 0 then
          begin
            if (Wini.Wterm[temp2 + i3].quote <= 0) or (WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].number < 0) or (WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].number >= useR.Rtype[Wini.Wterm[temp2 + i3].quote].datanum) then
              if warfile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].len > 1 then
                listbox1.Items.Add(displaystr(displayname(Wini.Wterm[temp2 + i3].name) + inttostr(i2 + 1) + tempstr + inttostr(WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].number)))
              else
                listbox1.Items.Add(displaystr(displayname(Wini.Wterm[temp2 + i3].name) + tempstr + inttostr(WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].number)))
            else
              if warfile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].len > 1 then
                listbox1.Items.Add(displaystr(displayname(Wini.Wterm[temp2 + i3].name)+ inttostr(i2 + 1) + tempstr + inttostr(WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].number) + readoutstr(useR.Rtype[Wini.Wterm[temp2 + i3].quote].Rdata[WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].number].Rdataline[useR.Rtype[Wini.Wterm[temp2 + i3].quote].namepos].Rarray[0].dataarray[0].str)))
              else
                listbox1.Items.Add(displaystr(displayname(Wini.Wterm[temp2 + i3].name) + tempstr + inttostr(WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].number) + readoutstr(useR.Rtype[Wini.Wterm[temp2 + i3].quote].Rdata[WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].number].Rdataline[useR.Rtype[Wini.Wterm[temp2 + i3].quote].namepos].Rarray[0].dataarray[0].str)));
          end
          else
            if warfile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].len > 1 then
              listbox1.Items.Add(displaystr(displayname(Wini.Wterm[temp2 + i3].name)+ inttostr(i2 + 1) +   tempstr + readoutstr(WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].str)))
            else
              listbox1.Items.Add(displaystr(displayname(Wini.Wterm[temp2 + i3].name) +   tempstr + readoutstr(WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].str)));
            //checklistbox1.Items.Add(Rini[combobox1.ItemIndex].Rterm[temp2 + i3].name + '          ' + (Pstring(@(RFile[combobox1.ItemIndex].Rdata[combobox2.ItemIndex].Rdataline[i1].Rarray[i2].dataarray[i3].str[0])))^);        i4 := 2;
          inc(temp);
          Wselect[temp].pos1 := i1;
          Wselect[temp].pos2 := i2;
          Wselect[temp].pos3 := i3;
          Wselect[temp].quote := Wini.Wterm[temp2 + i3].quote;
          Wselect[temp].note := Wini.Wterm[temp2 + i3].note;
        end;
      inc(temp2,WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[i1].Rarray[0].incnum);
    end;
  end;
end;

procedure TForm10.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  mainform.N10.Visible := false;
  CForm10 := true;
  action := cafree;
end;

procedure TForm10.FormCreate(Sender: TObject);
var
  I: integer;
  wareditbufbmp: Tbitmap;
   PalSize:longint;
    pLogPalle:TMaxLogPalette;
    PalleEntry:TPaletteEntry;
    Palle:HPalette;
begin

     PalSize:=sizeof(TLogPalette) + 256 * sizeof(TPaletteEntry);
     //pLogPalle:=MemAlloc(PalSize);
   //  getmem(Plogpalle, palsize);
     pLogPalle.palVersion:=$0300;
     pLogPalle.palNumEntries:=256;
     //
     for i:=0 to 255 do
     begin
     pLogPalle.palPalEntry[i].peRed:=McolR[I];
     pLogPalle.palPalEntry[i].peGreen:=McolG[I];
     pLogPalle.palPalEntry[i].peBlue:=McolB[I];
     pLogPalle.palPalEntry[i].peFlags:=PC_EXPLICIT;
     end;
   //
     Palle:=CreatePalette(pLogPalette(@plogpalle)^);
  readW(gamepath + wardata,@warFile);
  readWareditgrp;
  poseditmap:= tbitmap.Create;
  poseditmap.Width := 2304;
  poseditmap.Height := 1152;
  poseditmap.PixelFormat := pf8bit;
  poseditmap.Palette := palle;
  readwardef(gamepath + warmapdefidx,gamepath +warmapdefgrp,@wareditmapfile);
  CalWnamepos(@warFile);
  combobox1.Clear;
  for I := 0 to warfile.Wtype.datanum - 1 do
    combobox1.Items.Add(CalWname(I));
  combobox1.ItemIndex := 0;
  displayW;
  try
  statusbar1.Canvas.Brush.Style := bsclear;
  statusbar1.Canvas.Font.Size := 10;
  statusbar1.Canvas.Font.Color := clblack;
  displaywareditmap(@wareditmapfile.map[WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[warfile.Wtype.mappos].Rarray[0].dataarray[0].number], @poseditmap);
  wareditbufbmp := tbitmap.Create;
  wareditbufbmp.Width := image1.Width;
  wareditbufbmp.Height := image1.Height;
  wareditbufbmp.Canvas.StretchDraw(wareditbufbmp.Canvas.ClipRect,poseditmap);
  image1.Canvas.CopyRect(image1.Canvas.ClipRect, wareditbufbmp.Canvas, wareditbufbmp.Canvas.ClipRect);
  wareditbufbmp.free;
  except
    exit;
  end;

end;

procedure TForm10.FormResize(Sender: TObject);
begin
  listbox1.Columns := listbox1.Width div 300 +1;
end;

procedure TForm10.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  pointx,pointy,ayp,axp,ix,iy: integer;
begin
  pointx := image1.Width DIV 2;
  pointy := image1.Height div 2 - 31 * 6;
  Ayp := (-x + pointx + y -  pointy) div 6 + 1;
  Axp := (x - pointx + y -  pointy) div 6 + 1;
  statusbar1.Canvas.Brush.Color := clbtnface;
  statusbar1.Canvas.FillRect(statusbar1.Canvas.ClipRect);
  statusbar1.Repaint;
  statusbar1.Canvas.TextOut(10,10,'X='+ inttostr(axp) +',Y=' + inttostr(ayp));
end;

procedure TForm10.ListBox1DblClick(Sender: TObject);
var
  temp, I: integer;
begin
  if (listbox1.ItemIndex < length(Wselect)) and (listbox1.ItemIndex >= 0) then
  begin
    temp := listbox1.ItemIndex;
    if Wselect[listbox1.ItemIndex].quote <= 0 then
    begin
      if WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[wselect[listbox1.ItemIndex].pos1].Rarray[Wselect[listbox1.ItemIndex].pos2].dataarray[Wselect[listbox1.ItemIndex].pos3].datatype = 0 then
        WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[wselect[listbox1.ItemIndex].pos1].Rarray[Wselect[listbox1.ItemIndex].pos2].dataarray[Wselect[listbox1.ItemIndex].pos3].number := strtoint(InputBox('޸','޸Ĵֵ', inttostr(WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[Wselect[listbox1.ItemIndex].pos1].Rarray[Wselect[listbox1.ItemIndex].pos2].dataarray[Wselect[listbox1.ItemIndex].pos3].number)))
      else
        WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[Wselect[listbox1.ItemIndex].pos1].Rarray[Wselect[listbox1.ItemIndex].pos2].dataarray[Wselect[listbox1.ItemIndex].pos3].str := writeinstr(displaybackstr(InputBox('޸','޸Ĵַ', displaystr(readoutstr(WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[Wselect[listbox1.ItemIndex].pos1].Rarray[Wselect[listbox1.ItemIndex].pos2].dataarray[Wselect[listbox1.ItemIndex].pos3].str)))));
    end
    else
    begin
      Form6.ComboBox1.Clear;
      Form6.ComboBox1.Items.Add('-1');
      for I := 0 to useR.Rtype[Wselect[listbox1.ItemIndex].quote].datanum - 1 do
        Form6.ComboBox1.Items.Add(displaystr(inttostr(I) + readoutstr(useR.Rtype[Wselect[listbox1.ItemIndex].quote].Rdata[I].Rdataline[useR.Rtype[Wselect[listbox1.ItemIndex].quote].namepos].Rarray[0].dataarray[0].str)));
      Form6.ComboBox1.ItemIndex := WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[Wselect[listbox1.ItemIndex].pos1].Rarray[Wselect[listbox1.ItemIndex].pos2].dataarray[Wselect[listbox1.ItemIndex].pos3].number + 1;
      Form6.Label1.Caption := typename[Wselect[listbox1.ItemIndex].quote];
      if Form6.ShowModal = mrOK then
        WarFile.Wtype.Rdata[combobox1.ItemIndex].Rdataline[Wselect[listbox1.ItemIndex].pos1].Rarray[Wselect[listbox1.ItemIndex].pos2].dataarray[Wselect[listbox1.ItemIndex].pos3].number := Form6.ComboBox1.ItemIndex - 1;
      //Form6.Free;
    end;
    displayW;
    listbox1.ItemIndex := temp;
  end;
end;

procedure CalWnamePos(PWF: PWFile);
var
  temp, I: integer;
begin
  PWF.Wtype.namepos := -1;
  temp := -1;
  for I := 0 to Wtypedataitem - 1 do
  begin
    if wini.Wterm[I].datanum > 0 then
    begin
      inc(temp);
      if wini.Wterm[I].isname = 1 then
      begin
        PWF.Wtype.namepos := temp;
      end;
      if wini.Wterm[I].ismapnum = 1 then
      begin
        PWF.Wtype.mappos := temp;
      end;
    end;
  end;
end;

function calWname(index: integer): widestring;
var
  I: integer;
begin
  if (index >= 0) and (index < WarFile.Wtype.datanum) and (WarFile.Wtype.namepos >= 0) then
    result := inttostr(index) + widestring(displaystr(readoutstr(WarFile.Wtype.Rdata[index].Rdataline[WarFile.Wtype.namepos].Rarray[0].dataarray[0].str)))
  else
    result := inttostr(index);
  for I := 1 to length(result) - 1 do
    if result[I + 1] = '' then
    begin
      setlength(result, I);
      break;
    end;
end;

procedure readWareditgrp;
var
  offset: array of integer;
  I, idx, grp,temp: integer;
begin
  try
  idx := fileopen(gamepath + warmapidx, fmopenread);
  grp := fileopen(gamepath + warmapgrp, fmopenread);
  temp := fileseek(idx,0,2);
  setlength(wareditgrp, temp shr 2);
  setlength(offset, temp shr 2 + 1);
  fileseek(idx,0,0);
  fileread(idx, offset[1], temp);
  offset[0] := 0;
  fileseek(grp,0,0);
  for I := 0 to temp shr 2 - 1 do
  begin
    
    wareditgrp[I].size := offset[I + 1]- offset[I];
    setlength(wareditgrp[I].data, wareditgrp[I].size);
    fileread(grp, wareditgrp[I].data[0], wareditgrp[I].size);
  end;
  fileclose(idx);
  fileclose(grp);
  except
    //showmessage('');
    exit;
  end;

end;

procedure displaywareditmap(waropMap: Pmap; waropbmp2:PNTbitmap);
VAR
  ix,iy, I, i2,posx,posy: integer;
  pointx,pointy: integer;
begin
  pointx := WAROPBMP2.Width DIV 2;
  pointy := waropbmp2.Height div 2 - 31 * 18;
  waropbmp2.Canvas.Brush.Color := clblack;
  waropbmp2.Canvas.FillRect(waropbmp2.Canvas.ClipRect);
  for i := 0 to min(waropmap.x ,waropmap.y) - 1 do
  begin
    for ix := I to waropmap.x - 1 do
    begin
      posx := ix * 18 - I * 18  + pointx;
      posy := ix * 9 + I * 9 + pointy;
      for I2 := 0 to waropmap.layernum - 1 do
        if (waropmap.maplayer[I2].pic[I][ix] div 2 > 0) or (I2 = 0)  then
          McoldrawRLE8(@wareditgrp[waropmap.maplayer[I2].pic[I][ix] div 2].data[0],wareditgrp[waropmap.maplayer[I2].pic[I][ix] div 2].size,waropbmp2, posx, posy, true);
    end;
    for Iy := I + 1 to waropmap.y - 1 do
    begin
      posx := i * 18 - Iy * 18  + pointx;
      posy := i * 9 + Iy * 9 + pointy;
      for I2 := 0 to waropmap.layernum - 1 do
        if (waropmap.maplayer[I2].pic[Iy][i] div 2 > 0) or (I2 = 0) then
          McoldrawRLE8(@wareditgrp[waropmap.maplayer[I2].pic[Iy][i] div 2].data[0],wareditgrp[waropmap.maplayer[I2].pic[Iy][i] div 2].size,waropbmp2, posx, posy, true);
    end;
  end;
end;

end.
