unit grpedit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, StdCtrls, clipbrd, head;

type

  Tedittype = (pic, grp);

  TForm2 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Image2: TImage;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Image3: TImage;
    Label2: TLabel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure display;
    procedure Drawpallet;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
var
  drawbmp: Tbitmap;
  edittype: Tedittype;
  zoom: integer = 1;
  tempBitMaP: TBitmap;
  nowcol: cardinal = $FFFFFF;
  tempB,tempG,tempR: array[0..255] of byte;
  tempcollen: integer;

implementation

{$R *.dfm}

uses
  takein, grplist;

procedure TForm2.Button1Click(Sender: TObject);
var
  MyFormat : Word;
  AData : THandle;
  APalette : HPALETTE;
begin
  drawbmp.SaveToClipBoardFormat(MyFormat, AData, APalette);
  ClipBoard.SetAsHandle(MyFormat,AData);
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  if clipboard.HasFormat(CF_BITMAP) then
    drawbmp.LoadFromClipboardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap),0);
  display;
end;

procedure TForm2.Button3Click(Sender: TObject);
var
  I: integer;
begin
  if edittype = pic then
  begin
    can.Canvas.CopyRect(rect(takex,takey,picwidth + takex, picheight + takey), drawbmp.Canvas, drawbmp.Canvas.ClipRect);
  end
  else if edittype = grp then
  begin
    setlength(grppic[temppic].data, drawbmp.Width * drawbmp.Height * 2);
    grppic[temppic].size := pictoRLE8(@(grppic[temppic].data[0]),drawbmp.Width, drawbmp.Height, xmove, ymove, @DrawBMP, drawbmp.Canvas.ClipRect, true, usualtrans);
    //setlength(grppic[temppic].data,grppic[temppic].size);
    needdraw := true;
    for I := 0 to 255 do
    begin
      R[I] := tempR[I];
      B[I] := tempB[I];
      G[I] := tempG[I];
    end;
    collen := tempcollen;
  end;
  self.Close;
end;

procedure TForm2.Button4Click(Sender: TObject);
var
  tempcol1: cardinal;
  tempstr:string;
begin
  tempcol1 := (nowcol and $FF0000) shr 16 + nowcol and $FF00 + (nowcol and $FF) shl 16;
  tempstr := inputbox('Զɫ','ʮƷʽ루RGB',Format('%x',[tempcol1]));
  if strtoint('$' + tempstr) <> tempcol1 then
  begin
    tempcol1 := strtoint('$' + tempstr);
    nowcol := (tempcol1 and $FF0000) shr 16 + tempcol1 and $FF00 + (tempcol1 and $FF) shl 16;
    image3.Canvas.Brush.Color := nowcol;
    image3.Canvas.FillRect(image3.Canvas.ClipRect);
  end;
end;

procedure TForm2.Button5Click(Sender: TObject);
var
  tempw,temph, oriw,orih, ix, iy: integer;
begin
  tempw := strtoint(edit1.Text);
  temph := strtoint(edit2.Text);
  oriw := drawbmp.Width;
  orih := drawbmp.Height;
  drawbmp.Width := tempw;
  if tempw > oriw then
    for Ix := oriw to tempw - 1 do
      for iy := 0 to drawbmp.Height - 1 do
        drawbmp.Canvas.Pixels[ix, iy] := usualtrans;
  drawbmp.Height := temph;
  if temph > orih then
    for iy := orih to temph - 1 do
      for ix := 0 to drawbmp.Width - 1 do
        drawbmp.Canvas.Pixels[ix, iy] := usualtrans;
  display;
end;

procedure TForm2.ComboBox1Change(Sender: TObject);
begin
  case combobox1.ItemIndex of
    0:
      zoom := 1;
    1:
      zoom := 2;
    2:
      zoom := 4;
    3:
      zoom := 8;
    4:
      zoom := 16;
  end;
  display;

end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  drawbmp.Free;
  Action := caFree;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  image1.Width := drawbmp.Width;
  image1.Picture.Bitmap.Width := drawbmp.Width;
  image1.Height := drawbmp.Height;
  image1.Picture.Bitmap.Height := drawbmp.Height;
  if edittype = grp then
    panel2.Visible := true;
  zoom := 1;
  display;
  image2.Canvas.Brush.Color := clwhite;
  image2.Canvas.FillRect(image2.Canvas.ClipRect);
  Drawpallet;
  image3.Canvas.Brush.Color := nowcol;
  image3.Canvas.FillRect(image3.Canvas.ClipRect);
end;

procedure TForm2.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i1,i2,ix,iy: integer;
begin
  if speedbutton2.Down then
  begin
    nowcol := image1.Canvas.Pixels[x,y];
    image3.Canvas.Brush.Color := nowcol;
    image3.Canvas.FillRect(image3.Canvas.ClipRect);
  end
  else if speedbutton1.Down then
  begin
    drawbmp.Canvas.Pixels[x div zoom, y div zoom] := nowcol;
    //display;
    ix := x div zoom;
    iy := y div zoom;
    for i1 := ix * zoom to ix * zoom + zoom - 1 do
      for i2 := iy * zoom to iy * zoom + zoom - 1 do
        image1.Canvas.Pixels[i1, i2] := nowcol;
  end;
end;

procedure TForm2.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ((y div 16) * 12 + x div 16 < collen) then
  begin
    nowcol := image2.Canvas.Pixels[x,y];
    image3.Canvas.Brush.Color := nowcol;
    image3.Canvas.FillRect(image3.Canvas.ClipRect);
  end;
end;

procedure TForm2.display;
var
  ix, iy, i1, i2: integer;
  tempcol: cardinal;
  Pos, pos2: Pbyte;
  c1,c2,c3: byte;
begin
  //
  image1.Width := drawbmp.Width * zoom;
  image1.Picture.Bitmap.Width := drawbmp.Width * zoom;
  image1.Height := drawbmp.Height * zoom;
  image1.Picture.Bitmap.Height := drawbmp.Height * zoom;
  tempbitmap := Tbitmap.Create;
  tempbitmap.width := image1.Picture.Bitmap.Width;
  tempbitmap.height := image1.Picture.Bitmap.Height;
  tempbitmap.PixelFormat := pf24bit;
  drawbmp.PixelFormat := pf24bit;
  for ix := 0 to drawbmp.Width - 1 do
    for iy := 0 to drawbmp.Height - 1 do
    begin
      pos := drawbmp.ScanLine[iY];
      pos := pos + iX * 3;
      c1 := (pos)^;
      c2 := (pos + 1)^;
      c3 := (pos + 2)^;
      for i1 := ix * zoom to ix * zoom + zoom - 1 do
         for i2 := iy * zoom to iy * zoom + zoom - 1 do
         begin
           pos := tempbitmap.ScanLine[i2];
           pos := pos + i1 * 3;
           (pos)^ := c1;
           (pos + 1)^ := c2;
           (pos + 2)^ := c3;
           //tempbitmap.Canvas.Pixels[i1,  i2] := tempcol;
           //(tempbitmap.ScanLine[i2] + i1)^ := tempcol;
         end;
    end;
  image1.Canvas.CopyRect(image1.Canvas.ClipRect, tempbitmap.canvas, tempbitmap.canvas.cliprect);

end;

procedure TForm2.Drawpallet;
var
  ix, iy, i1, i2, i: integer;
  wide : integer;
begin
  wide := 12;
  //tempbmp := tbitmap.Create;
  //tempbmp.Width := wide * 16;
  //tempbmp.Height := wide * 16;
  //tempbmp.PixelFormat := pf24bit;
  //if edittype = pic then
 // begin
    for i := 0 to collen - 1 do
    begin
      iy := i div 16;
      ix := i mod 16;
      for i1 := ix * wide to ix * wide + wide - 1 do
        for i2 := iy * wide to iy * wide + wide - 1 do
        begin
          image2.canvas.pixels[i1, i2] := B[I] shl 16 + G[I] shl 8 + R[I];
          {pos := tempbmp.ScanLine[i2];
          (pos + i1 * 3)^ := R[I];
          (pos + i1 * 3 + 1)^ := G[I];
          (pos + i1 * 3 + 2)^ := B[I];}
        end;
    end;
    //image2.Canvas.CopyRect(image1.Canvas.ClipRect, tempbmp.Canvas, tempbmp.Canvas.ClipRect);
 // end;

end;

end.
