unit grplist;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, head, Menus, FileCtrl, PNGimage;

type

  TForm3 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Image1: TImage;
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    Edit3: TEdit;
    Button3: TButton;
    Button4: TButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    ComboBox1: TComboBox;
    Label1: TLabel;
    PNG1: TMenuItem;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    function judgeWH: Trect;
    procedure display;
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure PNG1Click(Sender: TObject);
    procedure Image1StartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GR, GG, GB: array[0..255] of byte;
  usualtrans: cardinal = $707030;
  grpcollen: integer;
  grppic: array of Tgrppic;
  linepic: integer = 10;
  filenum: integer = 0;
  nowpic: integer = -1;
  bufbmp: Tbitmap;
  Form3initial: boolean = false;

  squarew,squareh: integer;
  temppic: integer = -1;
  copynum: integer = -1;

  toeditbmp: Tbitmap;
  xmove,ymove: integer;
  needdraw: boolean = false;
  movelock : integer;

procedure drawRLE8(Ppic: Pbyte; len: integer; PBMP: PntBitMap; dx, dy: integer; canmove: boolean);
procedure copyGRP(AFrom, Ato:integer);

implementation

{$R *.dfm}

uses
  main, takein, grpedit;

procedure TForm3.Button1Click(Sender: TObject);
begin
  opendialog1.Filter := 'Idx files (*.Idx)|*.Idx|All files (*.*)|*.*';
  if opendialog1.Execute then
  begin
    edit1.Text := opendialog1.FileName;
  end;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
  opendialog1.Filter := 'Grp files (*.Grp)|*.Grp|All files (*.*)|*.*';
  if opendialog1.Execute then
  begin
    edit2.Text := opendialog1.FileName;
  end;
end;

procedure TForm3.Button3Click(Sender: TObject);
var
  H, len, i:integer;
begin
  opendialog1.Filter := 'Col files (*.Col)|*.Col|All files (*.*)|*.*';
  if opendialog1.Execute then
  begin
    edit3.Text := opendialog1.FileName;
    H := FIleopen(edit3.Text, fmopenread);
    len := fileseek(H, 0, 2);
    fileseek(H,0,0);
    grpcollen := len div 3;
    for I := 0 to grpcollen - 1 do
    begin
      fileread(H, GR[I], 1);
      fileread(H, GG[I], 1);
      fileread(H, GB[I], 1);
      GB[I] := GB[I] shl 2;
      GG[I] := GG[I] shl 2;
      GR[I] := GR[I] shl 2;
    end;
    fileclose(H);
  end;
end;

procedure TForm3.Button4Click(Sender: TObject);
var
  ScoH: integer;
  I: integer;
  offset: array of integer;
  idx,grp, filelen, param: integer;
begin
  if not(fileexists(edit1.Text) or fileexists(edit2.Text)) then
  begin
    showmessage('idxgrpļڣ');
    exit;
  end;
  idx := fileopen(edit1.Text, fmopenread);
  filelen := fileseek(idx, 0, 2);
  fileseek(idx, 0, 0);
  if filelen mod 4 <> 0 then
  begin
    showmessage('idxļ');
    exit;
  end;
  try
  filenum := filelen shr 2;
  setlength(offset, filenum);
  fileread(idx, offset[0], filelen);
  fileclose(idx);
  param := 0;
  setlength(grppic, filenum);
  grp := fileopen(edit2.Text, fmopenread);
  fileseek(grp,0,0);
  for I := 0 to filenum - 1 do
  begin
    grppic[i].size := offset[i] - param;
    param := offset[i];
    if GRPpic[I].size > 0 then
    begin
      setlength(GRPpic[i].data, grppic[i].size);
      fileread(grp, GRPpic[i].data[0], GRPpic[i].size);
    end;

  end;
  fileclose(grp);
  except

    showmessage('grpļI' + inttostr(I));
    exit;
  end;
  ScoH := filenum div linepic;
  scrollbar2.max := ScoH;
  scrollbar2.Position := 0;
  nowpic := 0;
  //nowpic := scrollbar2.position * linepic;
  try
    display;
  except
    showmessage('');
    exit;
  end;
  Form3initial := true;
end;

procedure TForm3.ComboBox1Change(Sender: TObject);
var
  temp: integer;
  namestr, opstr: string;
begin
  if ComboBox1.ItemIndex < grplistnum then
  begin
    if grplistnum > 0 then
    begin
      edit1.Text := gamepath + grplistidx[combobox1.itemindex];
      edit2.Text := gamepath + grplistgrp[combobox1.itemindex];
    end;
  end
  else
  begin
    temp := combobox1.ItemIndex;
    if grplistnum > 0 then
      temp := temp - grplistnum;

    if temp < 10 then
      namestr := '00'+inttostr(temp)
    else if temp < 100 then
      namestr := '0' + inttostr(temp)
    else
      namestr := inttostr(temp);
    opstr := fightidx;
    opstr := StringReplace(opstr,'***',namestr,[rfReplaceAll]);
    edit1.Text := gamepath + opstr;
    opstr := fightgrp;
    opstr := stringreplace(opstr, '***', namestr,[rfReplaceAll]);
    edit2.Text := gamepath + opstr;
  end;
  Button4Click(Sender);
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MainForm.GRP2.Visible := false;
  CFOrm3 := true;
  bufbmp.Free;
  Form3initial := false;
  action := cafree;
end;

procedure TForm3.FormCreate(Sender: TObject);
var
  H,len,I: integer;
  filename: string;
begin
  bufbmp := TBitmap.Create;
  bufbmp.Canvas.Brush.Color := usualtrans;
  bufbmp.Canvas.FillRect(bufbmp.Canvas.ClipRect);
  bufbmp.Canvas.Font.Color := clyellow;
  bufbmp.Canvas.Font.Size := 10;
  bufbmp.Canvas.Font.Name := '';
  bufbmp.Canvas.Brush.Style := bsclear;
  filename := gamepath + palette;
  if fileexists(filename) then
  begin
    edit3.Text := FileName;
    H := FIleopen(edit3.Text, fmopenread);
    len := fileseek(H, 0, 2);
    fileseek(H,0,0);
    grpcollen := len div 3;
    for I := 0 to grpcollen - 1 do
    begin
      fileread(H, GR[I], 1);
      fileread(H, GG[I], 1);
      fileread(H, GB[I], 1);
      GB[I] := GB[I] shl 2;
      GG[I] := GG[I] shl 2;
      GR[I] := GR[I] shl 2;
    end;
    fileclose(H);
  end;
  combobox1.Items.Clear;
  if grplistnum > 0 then
    for I := 0 to grplistnum - 1 do
      combobox1.Items.Add(displayname(grplistname[I]));
  if fightgrpnum > 0 then
    for I := 0 to fightgrpnum - 1 do
      combobox1.Items.Add(displayname(fightname + inttostr(I)));
end;

procedure TForm3.FormResize(Sender: TObject);
begin
  image1.Picture.Bitmap.Width := image1.Width;
  image1.Picture.Bitmap.Height := image1.Height;
  bufbmp.Width := image1.Width;
  bufbmp.Height := image1.Height;
  if Form3Initial then
    display;
end;

procedure TForm3.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Form3initial and (button = mbLeft) and (temppic < filenum) then
  begin
    image1.BeginDrag(true);
  end;
end;

procedure TForm3.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  ix, iy, sx,sy, caltemppic:integer;
begin
  //
  if needdraw then
  begin
    display;
    needdraw := false;
    temppic := -1;
  end;
  if Form3initial then
  begin
  sx := x div squarew;
  sy := y div squareh;


  caltemppic := sx + sy * linepic + nowpic;
  if sx < 10 then
  if caltemppic <> temppic then
  begin
    temppic := caltemppic;
    image1.Canvas.CopyRect(image1.Canvas.ClipRect,bufbmp.Canvas,bufbmp.Canvas.ClipRect);
    for ix := sx * squarew to sx * squarew + squarew - 1 do
    begin
      image1.Canvas.Pixels[ix, sy * squareh] := clred;
      image1.Canvas.Pixels[ix, sy * squareh + squareh] := clred;
    end;
    for iy := sy * squareh to sy * squareh + squareh do
    begin
      image1.Canvas.Pixels[sx * squarew, iy] := clred;
      image1.Canvas.Pixels[sx * squarew + squarew, iy] := clred;
    end;
  end;
  end;
end;

procedure TForm3.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (temppic < filenum) and (Button = mbRight)  and Form3initial then
  begin
    if copynum >= 0 then
      n4.Enabled := true
    else
      n4.Enabled := false;
    movelock := temppic;
    popupmenu1.Popup(x + self.Left,y + panel1.Height + self.Top);
  end;
end;

procedure TForm3.Image1StartDrag(Sender: TObject; var DragObject: TDragObject);
begin
  movelock := temppic;
  //image1.BeginDrag(true);
end;

procedure drawRLE8(Ppic: Pbyte; len: integer; PBMP: PntBitMap; dx, dy: integer; canmove: boolean);
var
  state,i, iy, ix, linesize, temp: integer;
  pw,ph,xs,ys: integer;
begin
  //
  if len >8 then
  begin
  pw := Psmallint((Ppic))^;
  Inc(Ppic, 2);
  ph := Psmallint((Ppic))^;
  Inc(Ppic, 2);
  xs := Psmallint((Ppic))^ + 1;
  Inc(Ppic, 2);
  ys := Psmallint((Ppic))^ + 1;
  Inc(Ppic, 2);


  if canmove then
  begin
    dy := dy - ys;
    dx := dx - xs;
  end;

  for iy := 0 to ph - 1 do
  begin
    linesize := Ppic^;
    inc(Ppic);
    state := 2;
    ix := dx;
    for I := 0 to linesize - 1 do
    begin
      if state = 2 then
      begin
        temp := (Ppic + I)^;
        ix := ix + temp;
        state := 1;
      end
      else if state = 1 then
      begin
        temp := (Ppic + I)^;
        state := 2 + temp;
      end
      else if state > 2 then
      begin
        temp := (Ppic + I)^;
        PBMP.canvas.Pixels[ix, iy + dy] := (GB[temp] shl 16) or (GG[temp] shl 8) or GR[temp];
        dec(state);
        inc(ix);
      end;


    end;
    inc(Ppic, linesize);
  end;
  end;

end;

function TForm3.judgeWH: Trect;
var
  Dw,dh, i, iy, ix, tempx, tempy, tempw, temppic, lines: integer;

begin
  dw := 0;
  dh := 0;
  iy := 0;
  ix := 0;
  temppic := nowpic;
  lines := 0;
  while iy < image1.height do
  begin
    inc(lines);
    tempx := 0;
    for I := 0 to linepic - 1 do
    begin
      tempw := (Psmallint(@(grppic[I + temppic].data[0])))^;
      inc(tempx, tempw);
      if tempw > dw then
        dw := tempw;
      tempy := (Psmallint(@(grppic[I + temppic].data[2])))^;
      if tempy > dh then
        dh := tempy;
    end;
    iy := dh * lines;
  end;
  if dw * linepic - image1.width >0 then
    scrollbar1.max := dw * linepic - image1.width;
  result.top := dh;
  result.left := dw;
  result.bottom := lines;
end;

procedure TForm3.N1Click(Sender: TObject);
var
  Form2: TForm2;
  i: integer;
begin
  drawbmp:= Tbitmap.Create;
  temppic := movelock;
  try
    drawbmp.Width := (Psmallint(@(grppic[temppic].data[0])))^;
    drawbmp.Height := (Psmallint(@(grppic[temppic].data[2])))^;
    xmove := (Psmallint(@(grppic[temppic].data[4])))^;
    Ymove := (Psmallint(@(grppic[temppic].data[6])))^;
  except
    drawbmp.Width := 0;
    drawbmp.Height := 0;
    xmove := 0;
    Ymove := 0;
  end;
  drawbmp.Canvas.Brush.Color := usualtrans;
  drawbmp.Canvas.FillRect(drawbmp.Canvas.ClipRect);
  try
    drawRLE8(@(grppic[temppic].data[0]),grppic[temppic].size,@drawbmp,0,0,false);
  except
    //
  end;

  edittype := grp;
  tempcollen := collen;
  collen := grpcollen;
  for I := 0 to 255 do
  begin
    tempR[I] := R[I];
    tempB[I] := B[I];
    tempG[I] := G[I];
    R[I] := GR[I];
    B[I] := GB[I];
    G[I] := GG[I];
  end;
  Form2 := TForm2.Create(application);
  Form2.Panel2.Visible := true;
  Form2.Drawpallet;
  Form2.Edit1.Text := inttostr(drawbmp.Width);
  Form2.Edit2.Text := inttostr(drawbmp.Height);
  Form2.Edit3.Text := inttostr(xmove);
  FOrm2.Edit4.Text := inttostr(ymove);
  Form2.Visible := false;
  Form2.ShowModal;

end;

procedure TForm3.N2Click(Sender: TObject);
var
  I: Integer;
begin
  temppic := movelock;
  if filenum = 1 then
    showmessage('ֻʣһͼƬɾ')
  else if temppic = filenum - 1 then
  begin
    dec(filenum);
    setlength(GRPpic, filenum);
  end
  else if temppic < filenum - 1 then
  begin
    for I := temppic to filenum - 2 do
      copygrp(I + 1, I);
    dec(filenum);
    setlength(GRPpic, filenum);
  end;
  temppic := -1;
  display;
end;

procedure TForm3.N3Click(Sender: TObject);
begin
  temppic := movelock;
  copynum := temppic;
end;

procedure TForm3.N4Click(Sender: TObject);
begin
  temppic := movelock;
  copyGRP(copynum, temppic);
  temppic := -1;
  display;
end;

procedure TForm3.N5Click(Sender: TObject);
var
  I, len: integer;
  idx, grp: integer;
begin
  len := 0;
  idx := filecreate(edit1.Text);
  grp := filecreate(edit2.Text);
  for I := 0 to filenum - 1 do
  begin
    inc(len, GRPpic[I].size);
    filewrite(idx, len, 4);
    if GRPpic[I].size > 0 then
      filewrite(grp, GRPpic[I].data[0], GRPpic[I].size);
  end;
  fileclose(idx);
  fileclose(grp);
end;

procedure TForm3.N6Click(Sender: TObject);
var
  I: integer;
begin
  inc(filenum);
  setlength(GRPpic, filenum);
  GRPpic[filenum - 1].size := 8;
  setlength(GRPpic[filenum - 1].data, GRPpic[filenum - 1].size);
  for I := 0 to GRPpic[filenum - 1].size - 1 do
    GRPpic[filenum - 1].data[I] := 0;
  temppic := -1;
  display;
end;

procedure TForm3.PNG1Click(Sender: TObject);
var
  I, PF : integer;
  dir,filename: string;
  Savebufbmp: Tbitmap;
  PNGrs: TPNGimage;
  ix,iy: integer;
  Pdat:Pbytearray;
begin
  //
  if SelectDirectory('ѡ񱣴ļ',dir,Dir) then
  begin
    if dir[length(dir)] <> '\' then
      dir :=dir + '\';
    savebufbmp := Tbitmap.Create;
    for I := 0 to filenum - 1 do
    begin
      if grppic[I].size > 8 then
      begin
        savebufbmp.Width := (Psmallint(@(grppic[I].data[0])))^;
        savebufbmp.height := (Psmallint(@(grppic[I].data[2])))^;
        savebufbmp.Canvas.Brush.Color := usualtrans;
        savebufbmp.Canvas.FillRect(savebufbmp.Canvas.ClipRect);
        drawRLE8(@(grppic[I].data[0]),grppic[I].size,@savebufbmp,0,0,false);
        PNGrs := TPNGimage.create;
        PNGrs.Assign(savebufbmp);
        PNGrs.CreateAlpha;
        for iy := 0 to savebufbmp.Height - 1 do
        begin
          Pdat := PNGrs.AlphaScanline[iy];
          for ix := 0 to savebufbmp.Width - 1 do
            if savebufbmp.Canvas.Pixels[ix, iy] = usualtrans then
              Pdat[ix] := 0;
        end;
        filename := dir + inttostr(I) +'.png';
        PNGrs.SaveToFile(filename);
        PNGrs.Free;
      end;
    end;
    showmessage('ɹ');
  end;
end;

procedure TForm3.ScrollBar1Change(Sender: TObject);
begin
  display;
end;

procedure TForm3.ScrollBar2Change(Sender: TObject);
begin
  nowpic := scrollbar2.Position * linepic;
  display;
end;

procedure TForm3.display;
var
  Arect: Trect;
  ix, iy, hd, wd: integer;
begin
  //
  //Arect := JudgeWH;

  bufbmp.Canvas.Brush.Style := bsSolid;
  bufbmp.Canvas.Brush.Color := usualtrans;
  bufbmp.Canvas.FillRect(bufbmp.Canvas.ClipRect);
  wd := image1.Width div linepic;
  hd := image1.Height div 180 + 1;
  squarew := wd;
  squareh := 180;
  bufbmp.Canvas.Font.Color := clyellow;
  bufbmp.Canvas.Font.Size := 10;
  bufbmp.Canvas.Font.Name := '';
  for iy := 0 to hd do
    for Ix := 0 to linepic - 1 do
    begin
      //drawRLE8(@(grppic[ix + nowpic + iy * linepic].data[0]),grppic[ix + nowpic + iy * linepic].size, @bufbmp, ix * Arect.Left - scrollbar1.Position, iy * Arect.Top, false);
      if ix + nowpic + iy * linepic < filenum then
      begin
      try
        drawRLE8(@(grppic[ix + nowpic + iy * linepic].data[0]),grppic[ix + nowpic + iy * linepic].size, @bufbmp, ix * wd, iy *squareh, false);

      except
        showmessage('ͼ'+ inttostr(ix + nowpic + iy * linepic));
      end;
      bufbmp.Canvas.Brush.Style := bsclear;
      bufbmp.Canvas.TextOut(ix * wd, iy * squareh, inttostr(ix + nowpic + iy * linepic));
      end;
    end;
    //drawRLE8(@Grppic[ix + nowpic + iy * linepic])
  image1.Canvas.CopyRect(image1.Canvas.ClipRect,bufbmp.Canvas,bufbmp.Canvas.ClipRect);
end;

procedure copyGRP(AFrom, Ato:integer);
var
  I: integer;
begin
  GRPpic[ATo].size := GRPpic[AFrom].size;
  setlength(GRPpic[ATo].data, GRPpic[ATo].size);
  for I := 0 to GRPpic[AFrom].size - 1 do
    GRPpic[ATo].data[I] := GRPpic[AFrom].data[I];
end;

end.
